
# erable Docker
erable powered by druapl 10 in docker environement (nginx, php:8.1-fpm+drush, mariadb, redis:4, phpmyadmin, x-debug)

## Install docker
```
sudo pacman -S docker docker-compose docker-machine
```
art the docker service
```
sudo systemctl start docker
```

For all the following, DO NOT run docker or make commande as root or with sudo, use this setup: add your user to the docker user group, re-login, and restart docker.service.

https://wiki.archlinux.org/index.php/Docker#Installation

## Clone this repos

this will clone this repos (main docker environement) and the erable.arch.fr drupal 9 source code (without sites/default folder nor mysq ddbs)

```
git clone --recursive -o figli https://figureslibres.io/gitea/bachir/docker-erable.git
```

submodules :
- https://figureslibres.io/gitea/bachir/drupal-erable

## touch log file
```
touch log/nginx/error.log
touch log/nginx/erable/error.log
```

### setup /sites/default/settings.php

```
cp -r ressources/drupal/settings.php src/web/sites/default/
cp -r ressources/drupal/settings.local.php src/web/sites/default/
cp -r ressources/drupal/services.yml src/web/sites/default/
```
### get the sites/default/salt.txt file (if you don't have it, you don't)

### get the sites/default/files folder
rsync the files from you know where (if you don't, you don't) to src/sites/default/files/

### xdebug
copy ```ressources/xdebug.ini.exemple``` to ```ressources/xdebug.ini``` and edit the ```xdebug.remote_host``` ip to your host locale ip (e.g. : 192.168.0.23) (or once the docker is started to the host ip from the container point of vu e.g. 172.21.0.1)

## Mysql
Copy your-sql-dump.sql files into ```./ressources/erable.sql```
They will be automaticly imported into the mysql containers dbs (only) on the first docker-compose up

## Hosts and reverse proxy

add to your /etc/hosts :
```
127.0.0.1	dev.erable.fr
127.0.0.1	dev.phpmyadmin.erable.fr
```
configure your vhosts to add a reverse proxy that will redirect the dev.materio.com to our container

### nginx

```sh
sudo mkdir /etc/var/log/erable
```

```nginx
server {
     listen 80;
     server_name dev.erable.fr;

     access_log off;
     error_log  /var/log/nginx/erable/error.log error;

     client_max_body_size 100m;

     location / {
         proxy_pass http://127.0.0.1:8980;
         proxy_set_header Host $host;
         proxy_set_header X-Real-IP $remote_addr;
         proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
         proxy_set_header X-Forwarded-Proto $scheme;
         proxy_buffer_size          128k;
         proxy_buffers              4 256k;
         proxy_busy_buffers_size    256k;
     }
 }
 server {
     listen 80;
     server_name dev.phpmyadmin.erable.fr;

     location / {
         proxy_pass http://127.0.0.1:8981;
         proxy_set_header Host $host;
         proxy_set_header X-Real-IP $remote_addr;
         proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
         proxy_set_header X-Forwarded-Proto $scheme;
         proxy_buffer_size          128k;
         proxy_buffers              4 256k;
         proxy_busy_buffers_size    256k;
     }
 }
```

### apache
```apache
<Virtualhost *:80>
  ServerName dev.erable.fr
  ProxyPass / http://127.0.0.1:8980/
  ProxyPassReverse / http://127.0.0.1:8980/
  ProxyRequests Off
  ProxyPreserveHost On
  proxy_buffer_size          128k;
  proxy_buffers              4 256k;
  proxy_busy_buffers_size    256k;
</Virtualhost>
<Virtualhost *:80>
  ServerName dev.phpmyadmin.erable.fr
  ProxyPass / http://127.0.0.1:8981/
  ProxyPassReverse / http://127.0.0.1:8981/
  ProxyRequests Off
  ProxyPreserveHost On
  proxy_buffer_size          128k;
  proxy_buffers              4 256k;
  proxy_busy_buffers_size    256k;
</Virtualhost>
```

## Docker

For all the following, DO NOT run docker or make commande as root or with sudo, use your regular user but first add your user to the docker user group, re-login, and restart docker.service.

```sh
usermod -aG docker yourusername
# https://wiki.archlinux.org/title/Docker#Installation
restart
```

### docker-compose pull
pull the latest image of services
```sh
make pull
```

### build
only before the first run (may take some time)
/!\ DO NOT use ```docker-compose build```, it will fail (check Makefile for more info)
```sh
make build
```

### run
then each time you want to launch the app
```sh
make up
```
Be aware that a first up, since the db is empty, it will be populated with your files ressources/db_d7.sql and ressources/db_d9.sql. It may take some time depending of your db size.

## Drupal Composer install
Only at first up, finish to install drupal 9 composer dependencies
```sh
make exec_php
composer install
# or juste
make composer_install
```

## Visualize
You can now visit http://dev.d7.erable.archi.fr and http://dev.d9.erable.archi.fr on your browser
After the first run

## Coding
### drush
you can access to drush by loging into the php container
```sh
make exec_php
```
once inside the php container in /var/www/html you can use drush as usual


## Updating code

```sh
git pull figli master
# then update all submodules
git submodule update --recursive --checkout
# if you updated d9 code then run
make maj_config
```

## Updating manualy the mysql db
copy your db backup into the mysql container
```sh
docker cp your-db-file.sql erable-mysql-1:/root/
```
log into mysql container
```sh
make exec_mysql
```
once inside the mysql container you can use mysql command to drop then create and load the db with your file
```
mysql -uroot -perable
> drop database erable;
> create database erable;
> exit;
mysql -uroot -perable erable < your-db-file-name.sql
```


## Makefile

DO NOT use directly docker or docker-compose to run this instance

use make instead like ```make up```

```makefile
#!/usr/bin/make

SHELL = /bin/sh

USER_UID := $(shell id -u)
USER_UNAME := $(shell id -un)
USER_GID := $(shell id -g)
USER_GNAME := $(shell id -gn)
DATE_NOW := $(shell date '+%Y-%m-%d_%H%M%S')

export USER_UID
export USER_UNAME
export USER_GID
export USER_GNAME
# export DATE_NOW


pull:
		docker-compose pull

build:
		docker-compose build --build-arg USER_UID=$(USER_UID) --build-arg USER_UNAME=$(USER_UNAME) --build-arg USER_GID=$(USER_GID) --build-arg USER_GNAME=$(USER_GNAME)

buildnc:
		docker-compose build --no-cache --build-arg USER_UID=$(USER_UID) --build-arg USER_UNAME=$(USER_UNAME) --build-arg USER_GID=$(USER_GID) --build-arg USER_GNAME=$(USER_GNAME)

downbuildup: down build up

up:
		docker-compose up -d

ps:
		docker-compose ps

logs:
		docker-compose logs -f

maj_config: crd composer_install updb cim cr pag #dev.phpmyadmin.erable.fr

crd:
		docker exec erable-php-1 /bin/bash -c "drush cache-clear drush"

composer_install:
		docker exec erable-php-1 /bin/bash -c "composer install --no-dev"

updb:
		docker exec erable-php-1 /bin/bash -c "drush updb -y"

cim:
		docker exec erable-php-1 /bin/bash -c "drush config-import -y"

# sync_struct:
# 		docker exec erable-php-1 /bin/bash -c "drush im --choice safe && drush ib --choice full"

cr:
		docker exec erable-php-1 /bin/bash -c "drush cr"

pag:
		docker exec erable-php-1 /bin/bash -c "drush pag all canonical_entities:node && drush pag all canonical_entities:taxonomy_term"

restart_nginx:
		docker-compose restart nginx

restart_php:
		docker-compose restart php

down:
		docker-compose down

exec_nginx:
		docker exec -it erable-nginx-1 bash

exec_php:
		docker exec -it erable-php-1 bash

exec_mysql:
		docker exec -it erable-mysql-1 bash

dump_db:
	docker exec erable-mysql-1 sh -c 'exec mysqldump -uroot -perable erable' > ./ressources/erable-$(DATE_NOW)-local.sql

```
